Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2232)
@@ -20,5 +20,10 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new topography and surface concept
+!   - now, also vertical walls are possible
+!   - for vertical walls, parametrization of r_a (aerodynamic resisistance) is 
+!     implemented. 
+!
+! Add check for soil moisture, it must not exceed its saturation value.
 ! 
 ! Former revisions:
@@ -159,4 +164,8 @@
 !> DALES and UCLA-LES models.
 !>
+!> @todo Extensive verification energy-balance solver for vertical surfaces, 
+!>       e.g. parametrization of r_a
+!> @todo Revise single land-surface processes for vertical surfaces, e.g. 
+!>       treatment of humidity, etc. 
 !> @todo Consider partial absorption of the net shortwave radiation by the 
 !>       skin layer.
@@ -174,6 +183,5 @@
  
     USE arrays_3d,                                                             &
-        ONLY:  hyp, ol, pt, pt_p, prr, q, q_p, ql, qsws, shf, ts, us, vpt, z0, &
-               z0h, z0q
+        ONLY:  hyp, pt, pt_p, prr, q, q_p, ql, vpt, u, v, w
 
     USE cloud_parameters,                                                      &
@@ -183,10 +191,10 @@
         ONLY:  cloud_physics, dt_3d, humidity, intermediate_timestep_count,    &
                initializing_actions, intermediate_timestep_count_max,          &
-               max_masks, precipitation, pt_surface,                           &
+               land_surface, max_masks, precipitation, pt_surface,             &
                rho_surface, roughness_length, surface_pressure,                &
                timestep_scheme, tsc, z0h_factor, time_since_reference_point
 
     USE indices,                                                               &
-        ONLY:  nbgp, nxlg, nxrg, nyng, nysg, nzb, nzb_s_inner 
+        ONLY:  nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb 
 
     USE kinds
@@ -196,11 +204,18 @@
     USE radiation_model_mod,                                                   &
         ONLY:  force_radiation_call, rad_net, rad_sw_in, rad_lw_out,           &
-               rad_lw_out_change_0, unscheduled_radiation_calls
+               rad_lw_out_change_0, radiation_scheme, unscheduled_radiation_calls
         
     USE statistics,                                                            &
         ONLY:  hom, statistic_regions
 
+    USE surface_mod,                                                        &
+        ONLY :  surf_lsm_h, surf_lsm_v, surf_type
+
     IMPLICIT NONE
 
+    TYPE surf_type_lsm
+       REAL(wp), DIMENSION(:),   ALLOCATABLE ::  var_1D !< 1D prognostic variable
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  var_2D !< 2D prognostic variable
+    END TYPE surf_type_lsm
 !
 !-- LSM model constants
@@ -225,14 +240,7 @@
                     soil_type = 3    !< NAMELIST soil_type_2d
 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  soil_type_2d, &  !< soil type, 0: user-defined, 1-7: generic (see list)
-                                                  veg_type_2d      !< vegetation type, 0: user-defined, 1-19: generic (see list)
-
-    LOGICAL, DIMENSION(:,:), ALLOCATABLE :: water_surface,     & !< flag parameter for water surfaces (classes 14+15)
-                                            pave_surface,      & !< flag parameter for pavements (asphalt etc.) (class 20)
-                                            building_surface     !< flag parameter indicating that the surface element is covered by buildings (no LSM actions, not implemented yet)
-
     LOGICAL :: conserve_water_content = .TRUE.,  & !< open or closed bottom surface for the soil model
-               force_radiation_call_l = .FALSE., & !< flag parameter for unscheduled radiation model calls
-               land_surface = .FALSE.              !< flag parameter indicating wheather the lsm is used
+               force_radiation_call_l = .FALSE., & !< flag to force calling of radiation routine
+               aero_resist_kray = .TRUE.           !< flag to control parametrization of aerodynamic resistance at vertical surface elements
 
 !   value 9999999.9_wp -> generic available or user-defined value must be set
@@ -288,100 +296,114 @@
               dz_soil                                                            !< soil grid spacing (edge-edge)
 
+
 #if defined( __nopointer )
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET :: t_surface,   & !< surface temperature (K)
-                                                     t_surface_p, & !< progn. surface temperature (K)
-                                                     m_liq_eb,    & !< liquid water reservoir (m)
-                                                     m_liq_eb_av, & !< liquid water reservoir (m)
-                                                     m_liq_eb_p     !< progn. liquid water reservoir (m)
+    TYPE(surf_type_lsm), TARGET  ::  t_soil_h,    & !< Soil temperature (K), horizontal surface elements
+                                     t_soil_h_p,  & !< Prog. soil temperature (K), horizontal surface elements
+                                     m_soil_h,    & !< Soil moisture (m3/m3), horizontal surface elements
+                                     m_soil_h_p     !< Prog. soil moisture (m3/m3), horizontal surface elements
+
+    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET  ::  &
+                                     t_soil_v,    & !< Soil temperature (K), vertical surface elements
+                                     t_soil_v_p,  & !< Prog. soil temperature (K), vertical surface elements
+                                     m_soil_v,    & !< Soil moisture (m3/m3), vertical surface elements
+                                     m_soil_v_p     !< Prog. soil moisture (m3/m3), vertical surface elements
 #else
-    REAL(wp), DIMENSION(:,:), POINTER :: t_surface,      &
-                                         t_surface_p,    & 
-                                         m_liq_eb,       & 
-                                         m_liq_eb_p
-
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET :: t_surface_1, t_surface_2, &
-                                                     m_liq_eb_av,              &
-                                                     m_liq_eb_1, m_liq_eb_2
+    TYPE(surf_type_lsm), POINTER ::  t_soil_h,    & !< Soil temperature (K), horizontal surface elements
+                                     t_soil_h_p,  & !< Prog. soil temperature (K), horizontal surface elements
+                                     m_soil_h,    & !< Soil moisture (m3/m3), horizontal surface elements
+                                     m_soil_h_p     !< Prog. soil moisture (m3/m3), horizontal surface elements 
+
+    TYPE(surf_type_lsm), TARGET  ::  t_soil_h_1,  & !<
+                                     t_soil_h_2,  & !<
+                                     m_soil_h_1,  & !<
+                                     m_soil_h_2     !<
+
+    TYPE(surf_type_lsm), DIMENSION(:), POINTER :: &
+                                     t_soil_v,    & !< Soil temperature (K), vertical surface elements
+                                     t_soil_v_p,  & !< Prog. soil temperature (K), vertical surface elements
+                                     m_soil_v,    & !< Soil moisture (m3/m3), vertical surface elements
+                                     m_soil_v_p     !< Prog. soil moisture (m3/m3), vertical surface elements   
+
+    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::&
+                                     t_soil_v_1,  & !<
+                                     t_soil_v_2,  & !<
+                                     m_soil_v_1,  & !<
+                                     m_soil_v_2     !<
+#endif    
+
+#if defined( __nopointer )
+    TYPE(surf_type_lsm), TARGET   ::  t_surface_h,    & !< surface temperature (K), horizontal surface elements 
+                                      t_surface_h_p,  & !< progn. surface temperature (K), horizontal surface elements 
+                                      m_liq_eb_h,     & !< liquid water reservoir (m), horizontal surface elements 
+                                      m_liq_eb_h_p      !< progn. liquid water reservoir (m), horizontal surface elements 
+
+    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET   ::  &
+                                      t_surface_v,    & !< surface temperature (K), vertical surface elements 
+                                      t_surface_v_p,  & !< progn. surface temperature (K), vertical surface elements 
+                                      m_liq_eb_v,     & !< liquid water reservoir (m), vertical surface elements 
+                                      m_liq_eb_v_p      !< progn. liquid water reservoir (m), vertical surface elements 
+#else
+    TYPE(surf_type_lsm), POINTER  ::  t_surface_h,    & !< surface temperature (K), horizontal surface elements 
+                                      t_surface_h_p,  & !< progn. surface temperature (K), horizontal surface elements 
+                                      m_liq_eb_h,     & !< liquid water reservoir (m), horizontal surface elements 
+                                      m_liq_eb_h_p      !< progn. liquid water reservoir (m), horizontal surface elements 
+
+    TYPE(surf_type_lsm), TARGET   ::  t_surface_h_1,  & !<
+                                      t_surface_h_2,  & !<
+                                      m_liq_eb_h_1,   & !<
+                                      m_liq_eb_h_2      !<
+
+    TYPE(surf_type_lsm), DIMENSION(:), POINTER  ::    &
+                                      t_surface_v,    & !< surface temperature (K), vertical surface elements 
+                                      t_surface_v_p,  & !< progn. surface temperature (K), vertical surface elements 
+                                      m_liq_eb_v,     & !< liquid water reservoir (m), vertical surface elements 
+                                      m_liq_eb_v_p      !< progn. liquid water reservoir (m), vertical surface elements 
+
+    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET   ::  &
+                                      t_surface_v_1,  & !<
+                                      t_surface_v_2,  & !<
+                                      m_liq_eb_v_1,   & !<
+                                      m_liq_eb_v_2      !<
 #endif
 
-!
-!-- Temporal tendencies for time stepping            
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: tt_surface_m,  & !< surface temperature tendency (K)
-                                             tm_liq_eb_m      !< liquid water reservoir tendency (m)
+#if defined( __nopointer )
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET :: m_liq_eb_av
+#else
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET :: m_liq_eb_av
+#endif
+
+#if defined( __nopointer )
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  t_soil_av, & !< Average of t_soil
+                                                        m_soil_av    !< Average of m_soil
+#else
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  t_soil_av, & !< Average of t_soil
+                                                        m_soil_av    !< Average of m_soil
+#endif
+
+    TYPE(surf_type_lsm), TARGET ::  tm_liq_eb_h_m   !< liquid water reservoir tendency (m), horizontal surface elements 
+    TYPE(surf_type_lsm), TARGET ::  tt_surface_h_m  !< surface temperature tendency (K), horizontal surface elements 
+    TYPE(surf_type_lsm), TARGET ::  tt_soil_h_m     !< t_soil storage array, horizontal surface elements 
+    TYPE(surf_type_lsm), TARGET ::  tm_soil_h_m     !< m_soil storage array, horizontal surface elements 
+
+    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::  tm_liq_eb_v_m   !< liquid water reservoir tendency (m), vertical surface elements 
+    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::  tt_surface_v_m  !< surface temperature tendency (K), vertical surface elements 
+    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::  tt_soil_v_m     !< t_soil storage array, vertical surface elements 
+    TYPE(surf_type_lsm), DIMENSION(0:3), TARGET ::  tm_soil_v_m     !< m_soil storage array, vertical surface elements 
 
 !
 !-- Energy balance variables                
     REAL(wp), DIMENSION(:,:), ALLOCATABLE :: &
-              alpha_vg,         & !< coef. of Van Genuchten
-              c_liq,            & !< liquid water coverage (of vegetated area)
               c_liq_av,         & !< average of c_liq
               c_soil_av,        & !< average of c_soil
-              c_veg,            & !< vegetation coverage
               c_veg_av,         & !< average of c_veg
-              f_sw_in,          & !< fraction of absorbed shortwave radiation by the surface layer (not implemented yet)
-              ghf_eb,           & !< ground heat flux
               ghf_eb_av,        & !< average of ghf_eb
-              gamma_w_sat,      & !< hydraulic conductivity at saturation
-              g_d,              & !< coefficient for dependence of r_canopy on water vapour pressure deficit
-              lai,              & !< leaf area index
               lai_av,           & !< average of lai
-              lambda_surface_s, & !< coupling between surface and soil (depends on vegetation type)
-              lambda_surface_u, & !< coupling between surface and soil (depends on vegetation type)
-              l_vg,             & !< coef. of Van Genuchten
-              m_fc,             & !< soil moisture at field capacity (m3/m3)
-              m_res,            & !< residual soil moisture
-              m_sat,            & !< saturation soil moisture (m3/m3)
-              m_wilt,           & !< soil moisture at permanent wilting point (m3/m3)
-              n_vg,             & !< coef. Van Genuchten  
-              qsws_eb,          & !< surface flux of latent heat (total)
               qsws_eb_av,       & !< average of qsws_eb
-              qsws_liq_eb,      & !< surface flux of latent heat (liquid water portion)
               qsws_liq_eb_av,   & !< average of qsws_liq_eb
-              qsws_soil_eb,     & !< surface flux of latent heat (soil portion)
               qsws_soil_eb_av,  & !< average of qsws_soil_eb
-              qsws_veg_eb,      & !< surface flux of latent heat (vegetation portion)
               qsws_veg_eb_av,   & !< average of qsws_veg_eb
-              rad_net_l,        & !< local copy of rad_net (net radiation at surface)
-              r_a,              & !< aerodynamic resistance 
               r_a_av,           & !< average of r_a
-              r_canopy,         & !< canopy resistance
-              r_soil,           & !< soil resistance
-              r_soil_min,       & !< minimum soil resistance
-              r_s,              & !< total surface resistance (combination of r_soil and r_canopy)
               r_s_av,           & !< average of r_s
-              r_canopy_min,     & !< minimum canopy (stomatal) resistance
-              shf_eb,           & !< surface flux of sensible heat
               shf_eb_av           !< average of shf_eb
-
-
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::                                 &
-              lambda_h, &   !< heat conductivity of soil (W/m/K)                            
-              lambda_w, &   !< hydraulic diffusivity of soil (?)
-              gamma_w,  &   !< hydraulic conductivity of soil (W/m/K)
-              rho_c_total   !< volumetric heat capacity of the actual soil matrix (?) 
-
-#if defined( __nopointer )
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                         &
-              t_soil,    & !< Soil temperature (K)
-              t_soil_av, & !< Average of t_soil
-              t_soil_p,  & !< Prog. soil temperature (K)
-              m_soil,    & !< Soil moisture (m3/m3)
-              m_soil_av, & !< Average of m_soil
-              m_soil_p     !< Prog. soil moisture (m3/m3)
-#else
-    REAL(wp), DIMENSION(:,:,:), POINTER ::                                     &
-              t_soil, t_soil_p, &
-              m_soil, m_soil_p    
-
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                         &
-              t_soil_av, t_soil_1, t_soil_2,                                   &
-              m_soil_av, m_soil_1, m_soil_2
-#endif
-
-
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::                                 &
-              tt_soil_m, & !< t_soil storage array
-              tm_soil_m, & !< m_soil storage array
-              root_fr      !< root fraction (sum=1) 
 
 
@@ -571,5 +593,5 @@
 !
 !-- Public parameters, constants and initial values
-    PUBLIC land_surface, skip_time_do_lsm
+    PUBLIC aero_resist_kray, skip_time_do_lsm
 
 !
@@ -578,11 +600,6 @@
 
 !
-!-- Public 2D output variables
-    PUBLIC ghf_eb, qsws_eb, qsws_liq_eb, qsws_soil_eb,qsws_veg_eb, r_a, r_s,   &
-           shf_eb
-
-!
 !-- Public prognostic variables
-    PUBLIC m_soil, t_soil
+    PUBLIC m_soil_h, t_soil_h
 
 
@@ -871,5 +888,5 @@
     USE control_parameters,                                                    &
         ONLY:  bc_pt_b, bc_q_b, constant_flux_layer, message_string,           &
-               most_method, topography
+               most_method
                  
     USE radiation_model_mod,                                                   &
@@ -879,5 +896,5 @@
     IMPLICIT NONE
 
- 
+    INTEGER(iwp) ::  k        !< running index, z-dimension
 !
 !-- Dirichlet boundary conditions are required as the surface fluxes are
@@ -897,10 +914,4 @@
     ENDIF
 
-    IF ( topography /= 'flat' )  THEN
-       message_string = 'lsm cannot be used ' //                            & 
-                        'in combination with  topography /= "flat"'
-       CALL message( 'check_parameters', 'PA0415', 1, 2, 0, 6, 0 )
-    ENDIF
-
     IF ( ( veg_type == 14  .OR.  veg_type == 15 ) .AND.                     &
            most_method == 'lookup' )  THEN
@@ -1044,4 +1055,14 @@
 
     ENDIF
+!
+!-- Check for proper setting of soil moisture, must not be larger than its 
+!-- saturation value. 
+    DO  k = nzb_soil, nzt_soil
+       IF ( soil_moisture(k) > m_soil_pars(0,soil_type) )  THEN 
+          message_string = 'soil_moisture must not exceed its saturation' // &
+                           ' value'
+          CALL message( 'check_parameters', 'PA0403', 1, 2, 0, 6, 0 )
+       ENDIF
+    ENDDO
 
     IF (  .NOT.  radiation )  THEN
@@ -1059,5 +1080,5 @@
 !> Solver for the energy balance at the surface.
 !------------------------------------------------------------------------------!
- SUBROUTINE lsm_energy_balance
+ SUBROUTINE lsm_energy_balance( horizontal, l )
 
 
@@ -1065,6 +1086,15 @@
 
     INTEGER(iwp) ::  i         !< running index
+    INTEGER(iwp) ::  i_off     !< offset to determine index of surface element, seen from atmospheric grid point, for x
     INTEGER(iwp) ::  j         !< running index
-    INTEGER(iwp) ::  k, ks     !< running index
+    INTEGER(iwp) ::  j_off     !< offset to determine index of surface element, seen from atmospheric grid point, for y
+    INTEGER(iwp) ::  k         !< running index
+    INTEGER(iwp) ::  k_off     !< offset to determine index of surface element, seen from atmospheric grid point, for z
+    INTEGER(iwp) ::  k_rad     !< index to access radiation array
+    INTEGER(iwp) ::  ks        !< running index
+    INTEGER(iwp) ::  l         !< surface-facing index
+    INTEGER(iwp) ::  m         !< running index concerning wall elements
+
+    LOGICAL      ::  horizontal !< Flag indicating horizontal or vertical surfaces
 
     REAL(wp) :: c_surface_tmp,& !< temporary variable for storing the volumetric heat capacity of the surface
